Package org.apache.sysds.runtime.controlprogram.caching

## Enum CacheableData.CacheStatus

- java.lang.Object
- - java.lang.Enum<CacheableData.CacheStatus>
  - - org.apache.sysds.runtime.controlprogram.caching.CacheableData.CacheStatus

All Implemented Interfaces:
  `Serializable`, `Comparable<CacheableData.CacheStatus>`

Enclosing class:
  CacheableData<T extends CacheBlock<?>>

    public static enum CacheableData.CacheStatus
    extends Enum<CacheableData.CacheStatus>

Defines all possible cache status types for a data blob. An object of class `CacheableData` can be in one of the following five status types: `EMPTY`: Either there is no data blob at all, or the data blob resides in a specified import file and has never been downloaded yet. `READ`: The data blob is in main memory; one or more threads are referencing and reading it (shared "read-only" lock). This status uses a counter. Eviction is NOT allowed. `MODIFY`: The data blob is in main memory; exactly one thread is referencing and modifying it (exclusive "write" lock). Eviction is NOT allowed. `CACHED`: The data blob is in main memory, and nobody is using nor referencing it. There is always an persistent recovery object for it

### Enum Constant Summary

Enum Constants
`CACHED`
`CACHED_NOWRITE`
`EMPTY`
`MODIFY`
`READ`

### Method Summary

All Methods Static Methods Concrete Methods
`static CacheableData.CacheStatus` `valueOf​(String name)` Returns the enum constant of this type with the specified name.
`static CacheableData.CacheStatus[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### EMPTY

    public static final CacheableData.CacheStatus EMPTY

#### READ

    public static final CacheableData.CacheStatus READ

#### MODIFY

    public static final CacheableData.CacheStatus MODIFY

#### CACHED

    public static final CacheableData.CacheStatus CACHED

#### CACHED_NOWRITE

    public static final CacheableData.CacheStatus CACHED_NOWRITE

### Method Detail

#### values

    public static CacheableData.CacheStatus[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (CacheableData.CacheStatus c : CacheableData.CacheStatus.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static CacheableData.CacheStatus valueOf​(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null